![repo-banner](.attachments/Images/repo-banner.png)

## Summary

Death Socket consists of three projects. They are a .Net Standard 2.0 library, a console program and a Test Centre. The purpose of this repository is to provide a way for people to add grids to images.

![death-socket-overview](.attachments/Images/death-socket-output-sample.jpg)

## Pre-Requisites

- Visual Studio (15.7+)
- F# (4.5+)
- FsCheck
- xUnit
- .Net Standard 2.0
- .Net (4.7+)
- Console.Waterworks

## Death Socket (Library/NuGet Package)

This is a .Net Standard 2.0 library. I wrote it in F# and it focuses on .Net 4.7+. To add it to your project use the following command in your Package-Manager console (assuming Visual Studio),

```powershell
// Make sure you change the version number to match the one you want.
Install-Package DeathSocket -Version 1.0.0.1
```

If you are using the .Net CLI, use the following,

```powershell
// Again, make sure you change the version number to the one you want.
dotnet add package DeathSocket --version 1.0.0.1
```

For more information, please visit the project's [wiki](https://git.abbether.net/craig.oates/Death-Socket/wiki/DeathSocket-Home).

![death-socket-overview](.attachments/Images/death-socket-overview.png)

## Death Socket CLI

This project is an F# console program, built with .Net 4.7. It uses Console.Waterworks to parse the users input/commands. I recommend you read the [Console.Waterworks wiki](https://git.abbether.net/craig.oates/Console.Waterworks/wiki) if you want to **extend** this project. It would, also, help you get a better understanding of how the console program works.

If you want to **use** the program, I recommend the `add-default` command. All you need to do is specify the path of the image you want to add the grid to and its new save location.

For further information, please visit the project's [wiki](https://git.abbether.net/craig.oates/Death-Socket/wiki/CLI-Home).

![death-socket-demo](.attachments/Images/death-socket-demo.gif)

If you have no need for the source code, just the functionality, then use this on its own. It is a full .Net console program so you will need to use [Mono](https://www.mono-project.com/) if you are using Linux or MacOS.

## Test Centre

This project holds all the tests for this repository. It uses a combination of unit tests ([xUnit](https://xunit.attachments.io/)) and property tests ([FsCheck](https://fscheck.attachments.io/FsCheck/)). If you are unfamiliar with either of them, click on their links for more information. Also, all the tests are accessible in Visual Studio's Test Explorer. This means you can identify passing and failing tests with ease.

![test-explorer](.attachments/Images/test-explorer.jpg)

## About the Creator

Hi, my name is Craig and I am the creator of Death Socket. Thank you checking it out and I hope you find it useful.

- Email: [craig@craigoates.net](mailto:craig@craigoates.net)
- Web: [craigoates.net](http://www.craigoates.net)
- Project: [craigoates.net/software/project/13](https://www.craigoates.net/Software/project/13)
